From a5590118fdca8c100131ae5a936e4801f9605310 Mon Sep 17 00:00:00 2001
From: Philip Hands <phil@hands.com>
Date: Wed, 15 Apr 2020 18:03:59 +0200
Subject: [PATCH 1/2] grammar fix: the verb 'play' calls for the adverb 'well'

---
 SPMainCore.py           | 2 +-
 po/childsplay_ar_SA.po  | 2 +-
 po/childsplay_ca_ES.po  | 2 +-
 po/childsplay_cs_CZ.po  | 2 +-
 po/childsplay_de_DE.po  | 2 +-
 po/childsplay_el_GR.po  | 2 +-
 po/childsplay_eo_EO.po  | 2 +-
 po/childsplay_es_ES.po  | 2 +-
 po/childsplay_fr_FR.po  | 2 +-
 po/childsplay_hu_HU.po  | 2 +-
 po/childsplay_it_IT.po  | 2 +-
 po/childsplay_latest.po | 2 +-
 po/childsplay_nb_NO.po  | 2 +-
 po/childsplay_nl_NL.po  | 2 +-
 po/childsplay_pl_PL.po  | 2 +-
 po/childsplay_pt_BR.po  | 2 +-
 po/childsplay_pt_PT.po  | 2 +-
 po/childsplay_ro_RO.po  | 2 +-
 po/childsplay_ru_RU.po  | 2 +-
 po/childsplay_sk_SK.po  | 2 +-
 po/childsplay_sl_SI.po  | 2 +-
 po/childsplay_sv_SE.po  | 2 +-
 po/childsplay_uk_UA.po  | 2 +-
 po/childsplay_vi_VN.po  | 2 +-
 24 files changed, 24 insertions(+), 24 deletions(-)

diff --git a/SPMainCore.py b/SPMainCore.py
index 302a94c..a565950 100644
--- a/SPMainCore.py
+++ b/SPMainCore.py
@@ -725,7 +725,7 @@ class MainCoreGui:
         if nextlevel and self.activity.get_name() != 'dltr':
             if levelup and (self.levelcount + self.dicebuttons.get_minimal_level() -1) < 6:
                 if not no_question and not self.no_levelup_dlg:
-                    dlg = Dialog(_("You play very good, do you want to try the next level ?"), \
+                    dlg = Dialog(_("You play very well, do you want to try the next level ?"), \
                             buttons=[_("No"), _("Yes")], title=_('Question ?'), dialogwidth=300)
                     dlg.run()
                     c = dlg.get_result()[0]
diff --git a/po/childsplay_ar_SA.po b/po/childsplay_ar_SA.po
index e328674..81ca841 100644
--- a/po/childsplay_ar_SA.po
+++ b/po/childsplay_ar_SA.po
@@ -959,7 +959,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "يتحتم عليك جعل الكرة الزرقاء تدخل الحفرة (في المستوى الأول)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_ca_ES.po b/po/childsplay_ca_ES.po
index 7fdceb3..3f48204 100644
--- a/po/childsplay_ca_ES.po
+++ b/po/childsplay_ca_ES.po
@@ -1028,7 +1028,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Heu de posar la bola blava al forat ( al nivell 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Jugues molt bé, ¿vols provar el següent nivell?"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_cs_CZ.po b/po/childsplay_cs_CZ.po
index 78100a1..e8606ae 100644
--- a/po/childsplay_cs_CZ.po
+++ b/po/childsplay_cs_CZ.po
@@ -953,7 +953,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Musíte dostat modrý míč do otvoru (v úrovni 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_de_DE.po b/po/childsplay_de_DE.po
index 866ffad..89daf72 100644
--- a/po/childsplay_de_DE.po
+++ b/po/childsplay_de_DE.po
@@ -974,7 +974,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Der blaue Ball muss in das Loch (in Level 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_el_GR.po b/po/childsplay_el_GR.po
index 5ff2a7c..fab2c7c 100644
--- a/po/childsplay_el_GR.po
+++ b/po/childsplay_el_GR.po
@@ -1054,7 +1054,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Πρέπει να βάλεις τη μπλε μπάλα στην τρύπα (Επίπεδο 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Παίζεις πολύ καλά. Μήπως θέλεις να προσπαθήσεις το επόμενο επίπεδο ;"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_eo_EO.po b/po/childsplay_eo_EO.po
index 9f6e452..84f6c1a 100644
--- a/po/childsplay_eo_EO.po
+++ b/po/childsplay_eo_EO.po
@@ -968,7 +968,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Vi devas enirigi la bluan globon en la truon (en nivelo 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_es_ES.po b/po/childsplay_es_ES.po
index c8592cf..9aa4aab 100644
--- a/po/childsplay_es_ES.po
+++ b/po/childsplay_es_ES.po
@@ -1033,7 +1033,7 @@ msgstr ""
 "Tienes que conseguir que la bola azul entre en el agujero (en el nivel 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Juegas muy bien, ¿quieres intentar el siguiente nivel?"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_fr_FR.po b/po/childsplay_fr_FR.po
index e93351a..29117bf 100644
--- a/po/childsplay_fr_FR.po
+++ b/po/childsplay_fr_FR.po
@@ -977,7 +977,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Tu dois faire entrer la boule bleue dans le trou (dans le niveau 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_hu_HU.po b/po/childsplay_hu_HU.po
index 014f9d0..0ce9a51 100644
--- a/po/childsplay_hu_HU.po
+++ b/po/childsplay_hu_HU.po
@@ -962,7 +962,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Az első szinten a kék golyót kell a lyukba löknöd,"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_it_IT.po b/po/childsplay_it_IT.po
index 540bfdb..639582c 100644
--- a/po/childsplay_it_IT.po
+++ b/po/childsplay_it_IT.po
@@ -973,7 +973,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Nel livello 1 devi far entrare in buca la palla blu mentre"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_latest.po b/po/childsplay_latest.po
index eba414d..9b81eed 100644
--- a/po/childsplay_latest.po
+++ b/po/childsplay_latest.po
@@ -933,7 +933,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr ""
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_nb_NO.po b/po/childsplay_nb_NO.po
index 9cc6c90..0788586 100644
--- a/po/childsplay_nb_NO.po
+++ b/po/childsplay_nb_NO.po
@@ -965,7 +965,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Målet i level 1 er å få den blå ballen ned i hullet"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_nl_NL.po b/po/childsplay_nl_NL.po
index 1ccb325..63fb742 100644
--- a/po/childsplay_nl_NL.po
+++ b/po/childsplay_nl_NL.po
@@ -1028,7 +1028,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Je moet zorgen dat de blauwe bal in het gat komt (in niveau 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Je speelt erg goed. Wil je het op een volgend niveau proberen?"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_pl_PL.po b/po/childsplay_pl_PL.po
index a815f5f..57477a2 100644
--- a/po/childsplay_pl_PL.po
+++ b/po/childsplay_pl_PL.po
@@ -969,7 +969,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Wprowadź niebieską kulę (bilę) do dziury (na poziomie 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_pt_BR.po b/po/childsplay_pt_BR.po
index d7b79ad..f0da124 100644
--- a/po/childsplay_pt_BR.po
+++ b/po/childsplay_pt_BR.po
@@ -1017,7 +1017,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Você tem que fazer a bola azul entrar no buraco (no nível 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Você jogou muito bem, você quer tentar o próximo nível ?"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_pt_PT.po b/po/childsplay_pt_PT.po
index edb5842..b87820a 100644
--- a/po/childsplay_pt_PT.po
+++ b/po/childsplay_pt_PT.po
@@ -970,7 +970,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Tens de fazer com que a bola azul entre no buraco(no nível 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_ro_RO.po b/po/childsplay_ro_RO.po
index 238ded4..2ec9594 100644
--- a/po/childsplay_ro_RO.po
+++ b/po/childsplay_ro_RO.po
@@ -973,7 +973,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Mingea albastră trebuie să intre în gaură (la nivel 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_ru_RU.po b/po/childsplay_ru_RU.po
index 6e1e463..10bed15 100644
--- a/po/childsplay_ru_RU.po
+++ b/po/childsplay_ru_RU.po
@@ -1018,7 +1018,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Надо загнать синий шар в лунку (на уровне 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr "Ты играешь очень хорошо, хочешь перейти на следующий уровнеь?"
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_sk_SK.po b/po/childsplay_sk_SK.po
index 8b155f4..8dd511f 100644
--- a/po/childsplay_sk_SK.po
+++ b/po/childsplay_sk_SK.po
@@ -957,7 +957,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Musíte modré gule dostať do otvoru (level 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_sl_SI.po b/po/childsplay_sl_SI.po
index 541b352..9f7aabc 100644
--- a/po/childsplay_sl_SI.po
+++ b/po/childsplay_sl_SI.po
@@ -958,7 +958,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Modro žogico morate spraviti v luknjo (v 1. nivoju)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_sv_SE.po b/po/childsplay_sv_SE.po
index da0d865..dfee5b7 100644
--- a/po/childsplay_sv_SE.po
+++ b/po/childsplay_sv_SE.po
@@ -961,7 +961,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Du måste få blå bollen in i hålet (på nivå 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_uk_UA.po b/po/childsplay_uk_UA.po
index af5fc07..1474685 100644
--- a/po/childsplay_uk_UA.po
+++ b/po/childsplay_uk_UA.po
@@ -974,7 +974,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Ви повинні зробити так, аби синя куля вкотилася у отвір (на рівні 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
diff --git a/po/childsplay_vi_VN.po b/po/childsplay_vi_VN.po
index 7a2d930..f10438a 100644
--- a/po/childsplay_vi_VN.po
+++ b/po/childsplay_vi_VN.po
@@ -940,7 +940,7 @@ msgid "You have to make the blue ball enter the hole (in level 1)"
 msgstr "Bạn phải đánh quả bóng màu xanh vào lỗ (trong cấp độ 1)"
 
 #: ../SPMainCore.py:728
-msgid "You play very good, do you want to try the next level ?"
+msgid "You play very well, do you want to try the next level ?"
 msgstr ""
 
 #: ../lib/electro_sp.py:196
-- 
2.20.1